/**
 * Datei: Point.java (Version .8)
 *
 * Die Klasse der Punkte einer Ebene, gefaerbt 
 * mit gekapselten Datenelementen
 * mit Methode zur Abstandsberechnung zwischen Punkten
 */

class Point {

  // Instanzvariablen (Datenelemente)
  private int x, y;
  private String color;

  // Konstruktoren
  Point() {
	x = 0;
	y = 0;
  }

  Point(int xInit, int yInit) {
	x = xInit;
	y = yInit;
  }

  Point(int xInit, int yInit, String colorInit) {
	x = xInit;
	y = yInit;
	color = colorInit;
  }

  // Methoden zum Abfragen der Werte der Datenelemente
  int getX() {
	return x;
  }

  int getY() {
	return y;
  }

  String getColor() {
	return color;
  }

  // Methoden absolutes Verschieben
  void moveTo(int xNew) {
	x = xNew;
  }

  void moveTo(int xNew, int yNew) {
	x = xNew;
	y = yNew;
  }

  // Methode relatives Verschieben
  void moveRel(int dx, int dy) {
	x = x + dx;
	y += dy;
  }

  // Methode: Abstand zum Ursprung
  double distance() {
	return Math.sqrt(x*x + y*y);
  }

  // Methode: Abstand zu einem anderen Punkt
  double distance(Point p) {
	int dx = x - p.x;
	int dy = y - p.y;
	return Math.sqrt(dx*dx + dy*dy);
  }

  // Methode zum Umfaerben
  void setColor(String colorNew) {
	color = colorNew;
  }
}

//Point.8 
